package com.siit.wfw.frame.utils;

import com.siit.wfw.frame.utils.ConfigUtils;
import com.siit.wfw.frame.utils.Convert;
import com.siit.wfw.frame.utils.DigestStrategy;
import com.siit.wfw.frame.utils.MD5;
import com.siit.wfw.frame.utils.SM3Util;
import com.siit.wfw.frame.utils.SpringContextUtils;
import java.util.HashMap;
import java.util.Map;

public class DigestAlgorithmUtil {

   private static final Map strategyMap = new HashMap();
   private static final DigestAlgorithmUtil instance = new DigestAlgorithmUtil();
   private static String algType = "";
   private ConfigUtils configUtils;


   public static DigestAlgorithmUtil getInstance() {
      return instance;
   }

   public static String encrypt(String arg1) {
      DigestStrategy digestStrategy = getInstance().getStrategy();
      return digestStrategy.doEncrypt((String)arg1);
   }

   public static String encrypt(byte[] arg1) {
      DigestStrategy digestStrategy = getInstance().getStrategy();
      return digestStrategy.doEncrypt((byte[])arg1);
   }

   public static boolean isSm3() {
      return "SM3".equals(algType);
   }

   private DigestStrategy getStrategy() {
      if(Convert.isNullOrEmpty(algType).booleanValue()) {
         if(this.configUtils == null) {
            this.configUtils = (ConfigUtils)SpringContextUtils.getApplication().getBean("configUtils");
         }

         String val = this.configUtils.getConfig("DIGEST_ALGORITHM");
         if(Convert.isNullOrEmpty(val).booleanValue()) {
            algType = "SM3";
         } else {
            algType = val;
         }
      }

      return (DigestStrategy)strategyMap.get(algType);
   }

   public static void main(String[] args) {
      System.out.println(encrypt((String)"测试下"));
      System.out.println(encrypt((String)"测试下"));
      System.out.println(encrypt((String)"测试下"));
   }

   static {
      strategyMap.put("SM3", new SM3Util());
      strategyMap.put("MD5", new MD5());
   }
}
